% Num. Math. - FS 2014 - Serie 2 Uebung 2 - Romberg Scheme

%a=0;
%b=1;
%f=@(x) exp(-x.^2);

a=0;
b=3;
f=@(x) sin(x).*exp(x);

TOL=1e-8;
MaxIter=10;

% attention: all indices shifted: Skript 0:MaxIter, Matlab 1:MaxIter+1
S=zeros(1,MaxIter+1);
T=zeros(1,MaxIter+1);
R=zeros(MaxIter+1, MaxIter+1);

h=b-a;
S(1)=(f(a)+f(b))/2;
T(1)=S(1)*h;
N=1;

R(1,1)=T(1);
for j=1:MaxIter
    % Trapezoidal method, page 93
    h=h/2; 
    S(j+1)=S(j)+sum(f(a+(2*(1:N)-1)*h));
    T(j+1)=h*S(j+1);    
    N=2*N;
    
    % Romberg iteration, page 98
    R(j+1,1)=T(j+1);
    for k=1:j
        R(j+1,k+1)=(R(j+1,k)-R(j,k)*4^(-k))/(1-4^(-k));
    end
    
    if abs(R(j+1,j+1)-R(j+1,j)) < abs(R(j+1,j+1)) *TOL + TOL;
        break;
    end
end
nIter=j
Integral=R(j+1,j+1)

% PLOT CONVERGENCE
%exact result with Matlabs quadrature routine:
MatlabQuad=quad(f,a,b,1e-12);

relErrorRomberg=abs( (diag(R(1:nIter+1,1:nIter+1)) - MatlabQuad)/MatlabQuad );
relErrorTrapezoidal=abs( (T(1:nIter+1) - MatlabQuad)/MatlabQuad );
semilogy(0:nIter, relErrorRomberg, 'o--',...
       0:nIter, relErrorTrapezoidal, 'kx--');
legend('Romberg R', 'Trapezoidal T');
xlabel('Iteration');
ylabel('relative Error');
title('Convergence of Relative Error');
