%% Num. Math. - FS 2014 - Serie 2 Uebung 3 (a-d) - Gauss quadrature


format long
f=@(x) 1./(1+cos(x).^2);
I_exact=pi/sqrt(2);

%nodes and weights on [-1,1]
x=[-0.90617985 -0.53846931 0 0.53846931 0.90617985];
w=[0.23692689 0.47862867 0.56888889 0.47862867 0.23692689];

%% QUADRATURE PART (a): 5 points
%nodes on [0,pi]
xx = (x+1) * pi/2;
%values of f in the nodes
fx=f(xx);

I_a= fx * w' *pi/2;


%% QUADRATURE PART (b): 3 subdomains with 5 points each
I_b = f(pi/6+pi/6*x) * w' * pi/6 ...
    + f(pi/2+pi/6*x) * w' * pi/6 ...
    + f(5*pi/6+pi/6*x) * w' * pi/6;


%% QUADRATURE PART (c): 15 points
[xc,wc] = lgwt(15,0,pi);
I_c = wc' * f(xc) ;


%% PART (d): comparison
disp('Exact                  5 points            3x5 points         15 points ')
values=[I_exact, I_a, I_b, I_c]
errors=[0, abs(I_exact-I_a), abs(I_exact-I_b), abs(I_exact-I_c)]

clf;
pla=plot(xx', 0.2, 'b*'); hold on;
plb=plot([pi/6+pi/6*x,  pi/2+pi/6*x,  5*pi/6+pi/6*x], 0.5, 'rd');
plc=plot(xc, 0.8, 'go');
plot([0,0], [0 1], 'k', [pi, pi], [0 1], 'k');
legend([pla(1),plb(1),plc(1)], 'nodes (a)','nodes (b)', 'nodes (c)')
hold off

