% Num. Math. - FS 2014 - Serie 2 Uebung 3(e) - Gauss quadrature in 2D

%  Smooth f:
f=@(x,y) y.*cos(x.*y/2);
I_exact=8;
x_min=-1; x_max=1; y_min=0; y_max=pi;

%  Example 2: smooth f
% f=@(x,y) (1-x.^2).*cos(y/2);
% I_exact=16/3;
% x_min=-1; x_max=1; y_min=-pi; y_max=pi;

%  Example 3: non-smooth f, look at the scale in the convergence plot!
% f=@(x,y) min(1-abs(x), 1-abs(y/pi));
% I_exact=4*pi/3;
% x_min=-1; x_max=1; y_min=-pi; y_max=pi;

k_max=10;    % maximal order of gauss quadrature
err=zeros(1,k_max);
for k=1:k_max
    [x,wx] = lgwt(k,x_min,x_max);
    [y,wy] = lgwt(k,y_min,y_max);
    [xx,yy]=meshgrid(x,y);
    I=sum(sum(f(xx,yy) .* (wy*wx')));
    err(k)=abs(I-I_exact);
end
QuadratureIntegral=I
Error=err(k_max)

% Error convergence plot and plot of f (on Gauss points)
clf;    subplot(1,2,1);
semilogy(err,'-*');
xlabel('Number of Gauss points');
ylabel('Error');

subplot(1,2,2);
surf(xx,yy,f(xx,yy));
title('f(x,y)');
axis equal;

